
import javax.media.j3d.*;

public class ColoringAttributesExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new ColoringAttributesExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Define vertex colours
    float[] colours = {1.0f, 0.0f, 0.0f, 
                       0.0f, 1.0f, 0.0f, 
                       0.0f, 0.0f, 1.0f};
    
    // Defines vertex coordinates
    float[] coordinates = {-0.8f, -0.4f,  0.0f, 
                            0.8f, -0.4f,  0.0f,
                            0.0f,  0.4f,  0.0f};
   
    GeometryArray geometryArray = new TriangleArray(3,
        GeometryArray.COORDINATES|
        GeometryArray.COLOR_3);
    
    geometryArray.setCoordinates(0, coordinates);
    geometryArray.setColors(0, colours);
    
    // Define the colouring attributes appearance component
    Appearance appearance = new Appearance();
    ColoringAttributes ca = new ColoringAttributes(1.0f, 1.0f, 0.0f, 
        ColoringAttributes.SHADE_FLAT);
    appearance.setColoringAttributes(ca);
    
    Shape3D shape = new Shape3D(geometryArray, appearance);
    root.addChild(shape);

    root.compile();

    return root;
  }
}
