import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;

public class DirectionalLightExample extends BasicScene
{
  public static void main(String args[]){new DirectionalLightExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
    
    Appearance appearance = new Appearance();
    
    // Create a material with a red diffuse colour
    Material material = new Material();
    material.setDiffuseColor(new Color3f(1.0f, 0.0f, 0.0f));
    appearance.setMaterial(material);
    
    Sphere sphere = new Sphere(0.5f, appearance);
    
    root.addChild(sphere);
    
    // Create a directional light with a bright white colour
    DirectionalLight light = new DirectionalLight(new Color3f(1.0f, 1.0f, 1.0f), 
        new Vector3f(-1.0f, -1.0f, -1.0f)); 
    light.setInfluencingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(light);
    
    root.compile();

    return root;
  }
}
