import javax.media.j3d.*;

public class IndexedGeometryExample extends BasicSceneWithMouseControl{
  
  public static void main(String args[]){new IndexedGeometryExample();}
  
  public BranchGroup createContentBranch()
  {
    BranchGroup root = new BranchGroup();
    
    // Defines the 8 vertices for the cube geometry
    float[] points = {-0.5f, -0.5f, -0.5f,
                       0.5f, -0.5f, -0.5f,
                      -0.5f,  0.5f, -0.5f,
                      -0.5f, -0.5f,  0.5f,
                      -0.5f,  0.5f,  0.5f,
                       0.5f, -0.5f,  0.5f,
                       0.5f,  0.5f, -0.5f,
                       0.5f,  0.5f,  0.5f};
    
    // Defines the 24 indices for the cube geometry
    int[] indices = {0, 3, 4, 2,   // left face
                     0, 1, 5, 3,   // bottom face
                     0, 2, 6, 1,   // back face
                     7, 5, 1, 6,   // right face
                     7, 6, 2, 4,   // top face
                     7, 4, 3, 5};  // front face 
    
    IndexedQuadArray quadArray = new IndexedQuadArray(8, 
        GeometryArray.COORDINATES, 24);
    quadArray.setCoordinates(0, points);
    quadArray.setCoordinateIndices(0, indices);
    
    Shape3D cube = new Shape3D(quadArray);
    
    root.addChild(cube);
    root.compile();
    
    return root;
  }
}
