
import javax.media.j3d.*;

public class LineAttributesExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new LineAttributesExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Define the vertex colours
    float[] colours = {0.0f, 1.0f, 0.0f, 
                       0.0f, 1.0f, 0.0f, 
                       0.0f, 0.0f, 1.0f, 
                       0.0f, 0.0f, 1.0f};
    
    // Defines the vertex coordinates
    float[] coordinates = {-0.8f, -0.2f,  0.0f, 
                            0.2f, 0.8f,  0.0f,
                            -0.2f, -0.8f,  0.0f, 
                            0.8f, 0.2f,  0.0f};
   
    GeometryArray geometryArray = new LineArray(4,
        GeometryArray.COORDINATES|
        GeometryArray.COLOR_3);
    
    geometryArray.setCoordinates(0, coordinates);
    geometryArray.setColors(0, colours);
    
    // Define the line attributes appearance component
    Appearance appearance = new Appearance();
    LineAttributes la = new LineAttributes();
    la.setLinePattern(LineAttributes.PATTERN_USER_DEFINED);
    la.setPatternMask(0xFFF0);
    la.setLineAntialiasingEnable(true);
    la.setLineWidth(5);
    appearance.setLineAttributes(la);
    
    Shape3D shape = new Shape3D(geometryArray, appearance);
    root.addChild(shape);

    root.compile();

    return root;
  }
}
