import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;

public class TransparencyAttributesExample extends BasicSceneWithMouseControl 
{

  public static void main(String args[]){new TransparencyAttributesExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
    
    Appearance appearance1 = new Appearance();

    // Create the first colouring attibutes appearance component
    ColoringAttributes ca1 = new ColoringAttributes(new Color3f(0.0f, 0.0f, 1.0f), 
        ColoringAttributes.SHADE_FLAT);
    appearance1.setColoringAttributes(ca1);
    
    // Create the transparency appearance compoennt that represents 
    // a 50% blended transparency
    TransparencyAttributes ta = new TransparencyAttributes();
    ta.setTransparencyMode(TransparencyAttributes.BLENDED);
    ta.setTransparency(0.5f);
    appearance1.setTransparencyAttributes(ta);
    
    // Add the first sphere to the root of the scene graph
    Sphere sphere = new Sphere(0.5f, appearance1);
    root.addChild(sphere);
    
    Appearance appearance2 = new Appearance();
    
    // Create the second colouring attributes appearance component
    ColoringAttributes ca2 = new ColoringAttributes(new Color3f(1.0f, 0.0f, 0.0f),
        ColoringAttributes.SHADE_FLAT);
    appearance2.setColoringAttributes(ca2);
    
    Transform3D transform = new Transform3D();
    transform.setTranslation(new Vector3f(-0.5f, 0.0f, -1.0f));
    TransformGroup tg = new TransformGroup(transform);
    root.addChild(tg);
    
    // Add the second sphere to the transform group
    Sphere sphere2 = new Sphere(0.5f, appearance2);
    tg.addChild(sphere2);
   
    root.compile();

    return root;
  }
}
